PROGRAM dougal;


    {Author        = Brett Stephen Parker}
    {Last Revision = 7th March 1993}


    { A tutorial package to demonstrate the concept of Genetic Algorithms}


    USES crt, graph, hci, deletion, population, evaluation, definitions;

    VAR index, ave,
        graphdriver,
        graphmode   : integer;
        again       : char;
        pop_rec     : pop_rec_type;
        best_store  : best_store_type;
        best_five   : best_five_type;
        pop_eval    : pop_ev_table_type;
        eval        : eval_store;
        setup       : setup_type;



BEGIN
  randomize;
  configure_screen(blue, blue, 2);
  set_window(top);
  write_title('                    - Setup Mode');
  set_window(middle);
  opening_screens(setup);
  REPEAT
    restorecrtmode;
    configure_screen(blue, blue, 1);
    set_window(top);
    write_title('                    - Setup Mode');
    IF setup.set_mode = 'f' THEN fast_setup(setup)
     ELSE guided_setup(setup);
    init_population(setup.pop_size, pop_rec.pop);
    pop_evaluation(setup.pop_size, pop_eval, pop_rec.pop);
    CASE setup.fitness OF

     'e' : fitness_is_evaluation(pop_eval, setup.pop_size,
                                 pop_rec.pop_fitness);

     'w' : windowing            (pop_eval, setup.guard, setup.pop_size,
                                 pop_rec.pop_fitness);

     'l' : linear_normalisation (pop_eval, setup.pop_size,
                                 setup.best_fitness, setup.dec,
                                 pop_rec.pop_fitness);

    END;
    show_and_store(setup.results, pop_rec, setup.pop_size, 0,
                   setup.print_mode, best_store, best_five);
    run_screen;
    CASE setup.del OF
     'a': delete_all(setup, pop_rec, best_store, best_five);
     's': steady_delete(setup, pop_rec, best_store, best_five);
    END;
    setcolor(blue);
    settextstyle(defaultfont, horizdir, 2);
    outtextxy(124, 392, 'Any key to alter settings');
    setcolor(yellow);
    outtextxy(32, 392, 'Any key to continue (Esc to Quit)');
    again := readkey;
  UNTIL ord(again) = 27;
  restorecrtmode;
  configure_screen(blue, blue, 1);
  configure_screen(black, lightgray, 2);
  write('Demonstration Of Using Genetic Algorithm Learning ');
  writeln('(c)Brett Parker @ UMIST 1993');
END.