UNIT population;

INTERFACE
USES definitions;

PROCEDURE init_population(pop_size: pop_size_type; VAR pop: pop_type);

PROCEDURE select_parent(pop_size  : integer;
                        pop_rec   : pop_rec_type;
                        VAR parent: chromo_type);

PROCEDURE quicksort(start, finish: integer; VAR eval: pop_ev_table_type;
                                            VAR pop: pop_type);


IMPLEMENTATION

PROCEDURE init_population(pop_size: pop_size_type; VAR pop: pop_type);

    TYPE cities_type = ARRAY [1..10] OF char;

    VAR index, loc, rnd_range, chromo_count: integer;
        chromo                             : chromo_type;
        cities                             : cities_type;

    PROCEDURE init_arrays;
    BEGIN
      chromo[1] := 'L';
      cities[1] := 'A';
      cities[2] := 'B';
      cities[3] := 'C';
      cities[4] := 'M';
      cities[5] := 'O';
      cities[6] := 'P';
      cities[7] := 'R';
      cities[8] := 'V';
      cities[9] := 'W';
      cities[10] := 'Z';
      chromo[12] := 'L';
      rnd_range := (chromo_length-2);
    END;

    PROCEDURE reset_cities;
    BEGIN
      IF loc < 2 THEN cities[1] := cities[2];
      IF loc < 3 THEN cities[2] := cities[3];
      IF loc < 4 THEN cities[3] := cities[4];
      IF loc < 5 THEN cities[4] := cities[5];
      IF loc < 6 THEN cities[5] := cities[6];
      IF loc < 7 THEN cities[6] := cities[7];
      IF loc < 8 THEN cities[7] := cities[8];
      IF loc < 9 THEN cities[8] := cities[9];
      IF loc < 10 THEN cities[9] := cities[10];
    END;

BEGIN
  FOR chromo_count := 1 TO pop_size DO
  BEGIN
    init_arrays;
    FOR index := 2 TO (chromo_length-1) DO
    BEGIN
      loc := random(rnd_range);
      loc := loc+1;
      chromo[index] := cities[loc];
      reset_cities;
      rnd_range := rnd_range - 1
    END;
    pop[chromo_count] := chromo;
  END;
END;

PROCEDURE select_parent(pop_size: integer;
                        pop_rec:pop_rec_type;
                        VAR parent:chromo_type);

    VAR target, index, range: integer;
        temp_eval_store     : eval_store;

BEGIN
  temp_eval_store := pop_rec.pop_fitness[pop_size];
  range := (temp_eval_store[3]);
  target := random(range);
  index := 0;
  REPEAT
    index:= index + 1;
    temp_eval_store := pop_rec.pop_fitness[index];
  UNTIL temp_eval_store[3] >= target;
  parent := pop_rec.pop[index];
END;

PROCEDURE quicksort(start, finish: integer; VAR eval: pop_ev_table_type;
                                            VAR pop: pop_type);

    VAR StarterValue, Left, Right: integer;
        temp                     : eval_store;
        temp_chromo              : chromo_type;

BEGIN
  left := start;
  right := finish;
  startervalue := eval[(start+finish) DIV 2, 1];
  REPEAT
    WHILE eval[left, 1] < starterValue DO
      left := left + 1;
    WHILE StarterValue < eval[right, 1] DO
      right := right - 1;
    IF left <= right THEN
    BEGIN
      temp := eval[left];
      temp_chromo := pop[left];
      eval[left] := eval[right];
      pop[left] := pop[right];
      eval[right] := temp;
      pop[right] := temp_chromo;
      left := left + 1;
      right := right -1;
    END;
  UNTIL right <= left;
  IF start < right THEN quicksort(start, right, eval, pop);
  IF left < finish THEN quicksort(left, finish, eval, pop)
END;

END.