UNIT reproduction;

INTERFACE

USES definitions, population;

PROCEDURE mate(pop_rec                             : pop_rec_type;
               pop_size, cross_percent, mut_percent: integer;
               VAR child1, child2                  : chromo_type);

IMPLEMENTATION

PROCEDURE mate(pop_rec                             : pop_rec_type;
               pop_size, cross_percent, mut_percent: integer;
               VAR child1, child2                  : chromo_type);

    VAR parent1, parent2: chromo_type;

    PROCEDURE mutate(premute: chromo_type; VAR postmute: chromo_type);

        TYPE mid_chromo = ARRAY [1..8] OF char;

        VAR temp                        : chromo_type;
            middle                      : mid_chromo;
            loc, first_cut, second_cut,
            count, index, rnd_range     : integer;


        PROCEDURE reset_temp;

        BEGIN
          IF loc < 2 THEN temp[1] := temp[2];
          IF loc < 3 THEN temp[2] := temp[3];
          IF loc < 4 THEN temp[3] := temp[4];
          IF loc < 5 THEN temp[4] := temp[5];
          IF loc < 6 THEN temp[5] := temp[6];
          IF loc < 7 THEN temp[6] := temp[7];
          IF loc < 8 THEN temp[7] := temp[8];
        END;

    BEGIN
      count := 1;
      FOR index := 1 TO 8 DO middle[index] := premute[index + 1];
      first_cut := random(8) + 1;
      second_cut := random(9 - first_cut) + first_cut;
      FOR index := first_cut TO second_cut DO
      BEGIN
        temp[count] := middle[index];
        count := count + 1;
      END;
      rnd_range := count - 1;
      FOR index := first_cut TO second_cut DO
      BEGIN
        loc := random(rnd_range);
        loc := loc + 1;
        premute[index + 1] := temp[loc];
        reset_temp;
        rnd_range := rnd_range - 1;
      END;
      postmute := premute;
    END;


    PROCEDURE crossover(parent1, parent2: chromo_type;
                        VAR child: chromo_type);

        TYPE template_type = ARRAY [1..chromo_length] OF Boolean;
             set_of_cities = SET OF char;
             element_list  = ARRAY [1..(chromo_length-2)] OF char;

        VAR template    : template_type;
            city_set    : set_of_cities;
            list        : element_list;
            count, index: integer;


    BEGIN
      FOR count := 1 TO chromo_length DO
      BEGIN
        IF random(2) < 1 THEN template[count] := false
        ELSE template[count] := true;
      END;
      template[1] := true;
      template[chromo_length] := true;
      city_set := [];
      FOR count := 1 TO chromo_length DO
      BEGIN
        IF template[count] THEN child[count] := parent1[count]
        ELSE city_set := city_set + [parent1 [count]];
      END;
      index := 1;
      FOR count := 2 TO (chromo_length - 1) DO
      BEGIN
        IF parent2[count] IN city_set THEN
        BEGIN
          list[index] := parent2[count];
          index := index + 1;
        END;
      END;
      index := 1;
      FOR count := 2 TO (chromo_length - 1) DO
      BEGIN
        IF NOT template[count] THEN
        BEGIN
          child[count] := list[index];
          index := index + 1;
        END;
      END;
    END;


BEGIN
  select_parent(pop_size, pop_rec, parent1);
  select_parent(pop_size, pop_rec, parent2);
  IF (random(100) < cross_percent) THEN
  BEGIN
    crossover(parent1, parent2, child1);
  END
   ELSE child1 := parent1;
  IF (random(100) < cross_percent) THEN
  BEGIN
    crossover(parent1, parent2, child2);
  END
   ELSE child2 := parent2;
  IF (random(1000) < mut_percent) THEN mutate(child1, child1);
  IF (random(1000) < mut_percent) THEN mutate(child2, child2);
END;

END.